package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/files"
	"git.perx.ru/perxis/perxis-go/pkg/files/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/files"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc files.Files, opts ...grpckit.ServerOption) pb.FilesServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		AbortUploadEndpoint:    grpcerr.ServerMiddleware(eps.AbortUploadEndpoint),
		CompleteUploadEndpoint: grpcerr.ServerMiddleware(eps.CompleteUploadEndpoint),
		DeleteFileEndpoint:     grpcerr.ServerMiddleware(eps.DeleteFileEndpoint),
		GetFileEndpoint:        grpcerr.ServerMiddleware(eps.GetFileEndpoint),
		MoveUploadEndpoint:     grpcerr.ServerMiddleware(eps.MoveUploadEndpoint),
		StartUploadEndpoint:    grpcerr.ServerMiddleware(eps.StartUploadEndpoint),
		UploadEndpoint:         grpcerr.ServerMiddleware(eps.UploadEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
